/*
 * xprwin - Displays the transfer window
 */

#include <stdio.h>
#include <stdarg.h>
#include <qdos.h>
#include <qlib.h>
#include <pd/xproto.h>

#include "xprdemo.h"
#include "xprmsg.h"

typedef struct
{
    short x;
    short y;
    char *Text;
}
XTITLES, *PXTITLES;

extern PXPRTHG pXB;

/*
 * This actually does a little more than just initialising the window.
 */

int InitXWindow (char *ptr, int IPipe, int OPipe, int dirn, int flag)
{
    char c;
    int m,n;
    short msgno;

    DrawXWindow();

    pXB->chid = pChId1;             /* The channel for status info (or NULL) */
    pXB->job = 0;                   /* Our Job (for PE pick & wake) */
    pXB->check = 0;                 /* The abort flag (MUST be 0 here)  */
    pXB->buf = ptr;                 /* The file names (if any) */
    pXB->flag = 0;                  /* Update status (normal please */
    pXB->icon = 0;                  /* Not needed here */
    pXB->status = flag;             /* I/O type (standard or QTPI/QeM) */
    pXB->logid = pChId2;            /* The log channel (or NULL) */
    
    msgno = dirn;

    /*
     * Send the command
     */

    n = io_sstrg (OPipe, -1, (char *) &msgno, 2);
    if(n > 0)
    {
        /*
         * Now await for either completion message from the
         * XPR Library or abort from the user
         */
        do
        {
            /*
             * Abort/skip CTRL-X, CTRL-Z, SHIFT f5
             */
             
            if(io_fbyte(pChId1, 5, &c) == 0)
            {
	        if (c == 26)
	        {
	            pXB->check = 1;
	        }
	        else if (c == 24 || c == 0xfa)
	        {
		    pXB->check = -1;
	        }
            }
        
        } while (io_pend(IPipe, 0) == -1);
        n = io_fstrg (IPipe, -1, (char *) &msgno, 2);
    }

    OutError("Any Key to continue .....");
    io_fbyte(pChId2, 250, &c);
    io_sbyte(pChId2, -1, '\n');
    return XPRTidy (pXB->status, n);
}

/*
 * Draws the initial transfer window
 */
 
static DrawXWindow ()
{
    short cw[4];
    static XTITLES XTtl[] =
    {
	{2, 0, "Protocol       :"},
	{2, 1, "File           :"},
	{2, 2, "Size           :"},
	{2, 3, "Bytes Sent     :"},
	{2, 4, "Block Check    :"},
	{2, 5, "Estimated Time :"},
	{2, 6, "Message        :"},
	{2, 7, "Last Error     :"},
	{2, 8, "No Errors      :"},
	{2, 9, "Packet Type    :"},
	{2, 10, "Char/Sec       :"},
	{40, 3, "Blocks Sent    :"},
	{40, 4, "Block Size     :"},
	{40, 5, "Elapsed Time   :"},
	{40, 8, "No Timeouts    :"},
	{40, 9, "Packet Delay   :"},
	{40, 10, "Char Delay     :"},
	{0, 0, NULL}
    };
    PXTITLES p;

    sd_clear(pChId1, -1);
    for (p = XTtl; p->Text; p++)
    {
	sd_pos (pChId1, -1, p->x, p->y);
	io_sstrg (pChId1, -1, p->Text, (short) strlen (p->Text));
    }
    sd_setin (pChId1, -1, WHITE_M4);
}
