#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <ctype.h>
#include "xproto.h"
#include "xprsealink.h"

char *progname = "QDOS SEALimp";	/* name of sending program */

/* File transmitter logic */

int ByteSwap(int val)
{
    unsigned int rval;
    
    rval = ((unsigned)val & 0xFF) << 24;
    rval |= ((unsigned)val & 0xFF00) << 8;
    rval |= ((unsigned)val & 0xFF0000) >> 8;
    rval |= ((unsigned)val & 0xFF000000) >> 24;  
    return (int)rval;  
}

int crc_update (nCRC, c)
unsigned int nCRC;
unsigned char c;
{
    unsigned short n;
    
    n = updcrc(c, (nCRC & 0xFFFF));
    return n;
}

int crc_finish (crc)
unsigned int crc;
{
unsigned short n;

    n = updcrc(0, updcrc(0, (crc & 0xFFFF)));

    return n & 0xFFFF;
}

int timerset (t1)
int t1;
{
    int t2;

    t2 = time (NULL);
    t2 += t1 / 10;
    return t2;
}

int timeup (t1)
{
    int t2;

    t2 = time (NULL);
    if (t2 > t1)
    {
	return 1;
    }
    else
    {
	return 0;
    }
}
void com_putc (X, c)
PXIO X;
char c;
{
    char b;

    b = c;
    (*X->xpr_swrite) (&b, 1);
}

int com_getc (X, t)
PXIO X;
int t;
{
    unsigned char b;
    int n;

    n = (*X->xpr_sread) (&b, 1, t);

    if (n == 1)
    {
	return b & 0xFF;
    }
    else
    {
	return EOF;
    }

}

key_scan ()
{
    return EOF;
}

com_dump ()
{
}
TXParse (fname, xname, xmode)
char *fname;
char *xname;
int xmode;
{
    char *p;
    char *q;
    int n;
    char c;

#ifndef QDOS
    for (p = fname, q = NULL; *p; p)
    {
	if (*p == ':' || *p == '/')
	{
	    q = ++p;
	}
	else
	{
	    p++;
	}
    }
#else
    p = fname;
    q = strchr (p, '_');
    if (q)
    {
	q++;
	c = *q;
	*q = 0;
	if (isdirdev (p))
	{
	    *q = c;
	}
	else
	{
	    *q = c;
	    q = p;
	}
    }
    else
    {
	q = p;
    }
    p = strrchr (q, '_');
    if (p && xmode)
    {
	*p = '.';
    }
#endif
    if (q == NULL)
    {
	q = fname;
    }
    n = strlen (q);
    if (n > 16)
    {
	q = q + (n - 16);
    }
    strcpy (xname, q);
}

/* File transmitter logic */

int xmtfile (X)
PXIO X;
{
    long t1;            	/* timers */
    int c;			/* one byte of data */
    int endblk;			/* block number of EOT */
    XPRU u;
    int rstat;
    
    if (XD->FileName && *XD->FileName) /* if sending a file */
    {
	XD->filesize = (*X->xpr_finfo) (XD->FileName, 1);
	XD->outblk = 0;
	XD->ackblk = 0;
	XD->blksnt = 0;
	XD->slide = 0;
	XD->ackst = 0;
	XD->numnak = 0;
	XD->starttime = 0;
	XD->numerrs = 0;
	XD->numtime = 0;
	XD->chktec = 1;
	XD->abort = 0;
	XD->Xmode = (XD->QLXlate == 'Y');
	XD->fp = 0;
	if (!(XD->fp = (*X->xpr_fopen) (XD->FileName, "r")))
	{
	    DOUpdate (X, FILERR);
	    return ERROR;
	}

        if(X->xpr_setserial)
        {
            (*X->xpr_setserial)(3);
        }

	setmem (&XD->zero, sizeof (struct zeros), 0);	/* clear out data block */

	XD->zero.flen = ByteSwap(XD->filesize);
	TXParse (XD->FileName, XD->zero.fnam, (int)XD->Xmode);
	strcpy (XD->zero.prog, progname);

	endblk = ((XD->filesize + 127) / 128) + 1;
	XD->starttime = time (NULL);
	setmem (&u, sizeof (u), 0);
	u.xpru_filename = XD->FileName;
	u.xpru_filesize = XD->filesize;
	u.xpru_msg = "Waiting";
	u.xpru_errormsg = "";
	u.xpru_blocksize = 128;
	u.xpru_blockcheck = (XD->chktec) ? "CRC-16" : "Checksum";
	u.xpru_updatemask = XPRU_FILENAME | XPRU_FILESIZE |
	    XPRU_MSG | XPRU_ERRORMSG | XPRU_BLOCKSIZE |
	    XPRU_ERRORS | XPRU_TIMEOUTS;
	(*X->xpr_update) (&u);
    }
    else
    {
	endblk = 0;		/* fake for no file */
    }

    XD->outblk = 1;		/* set starting state */
    XD->ackblk = -1;
    XD->blksnt = XD->slide = XD->ackst = XD->numnak = 0;
    XD->chktec = 2;		/* undetermined */
    XD->bytes = 0;
    XD->EOTBlk = endblk;
    
    t1 = timerset (300);	/* time limit for first block */

    while (XD->ackblk < endblk)	/* while not all there yet */
    {
	if (X->xpr_chkabort && (*X->xpr_chkabort) ())
	{
	    DOUpdate (X, ABORTED);
	    goto abort;
	}
	if (timeup (t1))
	{
            DOUpdate (X, TIMEOUT);
	    goto abort;
	}

	if (XD->outblk <= XD->ackblk + (XD->slide ? 4 : 1))
	{
	    if (XD->outblk < endblk)
	    {
		if (XD->outblk > 0)
		{
		    sendblk (X, XD->outblk);
		    XD->bytes = XD->outblk * 128;
		    DOUpdate (X, OK);
		}
		else
		{
		    shipblk (X, &(XD->zero), 0);
	            u.xpru_msg = "Sending";
	            u.xpru_updatemask = XPRU_MSG;
                    (*X->xpr_update) (&u);
		}
	    }
	    else if (XD->outblk == endblk)
	    {
		com_putc (X, EOT);
	    }
	    XD->outblk++;
	    t1 = timerset (100);	/* time limit between blocks */
	}

	ackchk (X);
	if (XD->numnak > 10)
	{
	    DOUpdate (X, FAILED);
	    goto abort;
	}
    }

    rstat = OK;			/* exit with good status */
    goto xdone;
    
  abort:
    rstat = ERROR;		/* exit with bad status */
  xdone:
    if (endblk)
    {
	(*X->xpr_fclose) (XD->fp);
    }
    return rstat;
}

/* The various ACK/NAK states are: 0:   Ground state, ACK or NAK expected. 1: 
 * ACK received 2:   NAK received 3:   ACK, block# received 4:   NAK, block#
 * received 5:   Returning to ground state */

static ackchk (X)		/* check for ACK or NAK */
PXIO X;
{
    int c;			/* one byte of data */
    static int rawblk;		/* raw block number */

    while ((c = com_getc (X, 0)) != EOF)
    {
	if (XD->ackst == 3 || XD->ackst == 4)
	{
	    XD->slide = 0;		/* assume this will fail */
	    if (rawblk == c ^ 0xff)	/* see if we believe the number */
	    {
		rawblk = XD->outblk - ((XD->outblk - rawblk) & 0xff);
		if (rawblk <= XD->outblk && rawblk > XD->outblk - 20)
		{
		    XD->slide = 1;	/* we have sliding window! */
		    if (XD->ackst == 3)
			XD->ackblk = XD->ackblk > rawblk ? XD->ackblk : rawblk;
		    else
		    {
			XD->outblk = rawblk < 0 ? 0 : rawblk;
			com_dump ();	/* purge pending output */
		    }
		}
	    }
	    XD->ackst = 5;		/* return to ground state */
	}

	if (XD->ackst == 1 || XD->ackst == 2)
	{
	    rawblk = c;
	    XD->ackst += 2;
	}

	if (!XD->slide || XD->ackst == 0)
	{
	    if (c == ACK)
	    {
		if (!XD->slide)
		{
		    XD->ackblk++;
		}
		XD->ackst = 1;
		XD->numnak = 0;
	    }

	    else if (c == 'C' || c == NAK)
	    {
		if (XD->chktec > 1)	/* if method not determined yet */
		    XD->chktec = (c == 'C');	/* then do what rcver wants */

		if (!XD->slide)
		{
		    XD->outblk = XD->ackblk + 1;
		}
		XD->ackst = 2;
		XD->numnak++;
	    }
	}

	if (XD->ackst == 5)
	    XD->ackst = 0;
    }
}

static sendblk (X, blknum)	/* send one block */
PXIO X;
int blknum;
{
    long blkloc;		/* address of start of block */
    char buf[128];		/* one block of data */

    if (blknum != XD->blksnt + 1)	/* if jumping */
    {
	blkloc = (long) (blknum - 1) * 128L;
	(*X->xpr_fseek) (XD->fp, blkloc, 0);	/* move where to */
    }
    XD->blksnt = blknum;

    memset (buf, 26, (unsigned) 128);	/* fill buffer with control Zs */
    (*X->xpr_fread) (buf, 1, 128, XD->fp);	/* read in some data */
    shipblk (X, buf, blknum);	/* pump it out the comm port */
}

static int shipblk (X, blk, blknum)	/* physically ship a block */
PXIO X;
char *blk;			/* data to be shipped */
int blknum;			/* number of block */
{
    char *b = blk;		/* data pointer */
    int crc = 0;		/* CRC check value */
    int n;			/* index */

    com_putc (X, SOH);		/* block header */
    com_putc (X, blknum);		/* block number */
    com_putc (X, blknum ^ 0xff);	/* block number check value */

    for (n = 0; n < 128; n++)	/* ship the data */
    {
	if (XD->chktec)
	    crc = crc_update (crc, *b);
	else
	    crc += *b;
	com_putc (X, *b++);
    }

    if (XD->chktec)			/* send proper check value */
    {
	crc = crc_finish (crc);
	com_putc (X, crc >> 8);
	com_putc (X, crc & 0xff);
    }
    else
	com_putc (X, crc);

    return OK;
}

/* File receiver logic */

int rcvfile (X)			/* receive file */
PXIO X;
{
    int c;			/* received character */
    int tries;			/* retry counter */
    long t1;            	/* timer */
    int blknum;			/* desired block number */
    int inblk;			/* this block number */
    FILE *f;        		/* file, opener */
    char buf[128];		/* data buffer */
    char tmpname[100];		/* name of temporary file */
    static char outname[100];	/* name of final file */
    int endblk;			/* block number of EOT, if known */
    long left;			/* bytes left to output */
    int n;			/* index */

    XPRU u;
    
    XD->outblk = 0;
    XD->ackblk = 0;
    XD->blksnt = 0;
    XD->slide = 0;
    XD->ackst = 0;
    XD->numnak = 0;
    XD->starttime = 0;
    XD->filesize = 0;
    XD->numerrs = 0;
    XD->numtime = 0;
    XD->chktec = 1;
    XD->abort = 0;
    XD->Xmode = (XD->QLXlate == 'Y');
    XD->fp = 0;

    if(X->xpr_setserial)
    {
        (*X->xpr_setserial)(3);
    }

    if (X->xpr_filename && *X->xpr_filename)	/* figure out a name to use */
	strcpy (XD->FileName, X->xpr_filename);
    else
	strcpy (XD->FileName, "unknown_$$$");

    if (*XD->DefDir)
    {
	strcpy (tmpname, XD->DefDir);
    }

    strcat (tmpname, XD->FileName);

    if (!(XD->fp = (*X->xpr_fopen) (tmpname, "wb")))	/* open output file */
    {
	DOUpdate (X, FILERR);
	return ERROR;
    }

    XD->starttime = time (NULL);
    blknum = 1;			/* start with block #1 */
    tries = -10;		/* kludge for first time around */
    XD->chktec = 1;		/* try for CRC error checking */
    endblk = 0;			/* we don't know the size yet */
    XD->bytes = 0;
    setmem (&XD->zero, sizeof (XD->zero), 0);	/* or much of anything else */

  nakblock:			/* we got a bad block */

    if(tries != -10)
    {
        DOUpdate(X, NAK);
    }

    if (++tries > 10)
    {
	DOUpdate (X, DONE);
	goto abort;
    }
    if (tries == 0)		/* if CRC isn't going */
    {
	XD->chktec = 0;		/* then give checksum a try */
	XD->numtime = 0;
	DOUpdate (X, MODE);
    }

    sendack (X, 0, blknum);	/* send the NAK */
    goto nextblock;

  ackblock:			/* we got a good block */

  nextblock:			/* start of "get a block" */
    if (X->xpr_chkabort && (*X->xpr_chkabort) ())
    {
	DOUpdate (X, ABORTED);
	goto abort;
    }

    t1 = timerset (50);		/* timer to start of block */
    while (!timeup (t1))
    {
	c = com_getc (X, 0);
	if (c == EOT)
	{
	    if (!endblk || endblk == blknum)
		goto endrcv;
	}
	else if (c == SOH)
	{
	    inblk = com_getc (X, 5);
	    if (com_getc (X, 5) == (inblk ^ 0xff))
		goto blockstart;	/* we found a start */
	}
    }
    XD->numtime++;
    DOUpdate (X, TIMEOUT);
    goto nakblock;

  blockstart:			/* start of block detected */
    c = blknum & 0xff;
    if (inblk == c)		/* if this is the one we want */
    {
	if (getblock (X, buf) == OK)	/* else if we get it okay */
	{
	    sendack (X, 1, inblk);	/* ack the data */
	    if (left > 128)
	    {
		n = 128;
	    }
	    else
	    {
		n = left;
	    }
	    left -= n;
	    if (((*X->xpr_fwrite) (buf, 1, n, XD->fp)) != n)
	    {
		DOUpdate (X, FILERR);
		goto abort;
	    }

	    tries = 0;		/* reset try count */
	    blknum++;		/* we want the next block */
	    XD->bytes += 128;
	    XD->blksnt = blknum;
	    DOUpdate (X, OK);
	    goto ackblock;
	}
	else
	{
	    XD->numerrs++;
	    DOUpdate (X, (XD->chktec) ? CRCERR : CHKERR);
	    goto nakblock;	/* ask for a resend */
	}
    }
    else if (inblk == 0 && blknum == 1)		/* else if this is the header */
    {
	if (getblock (X, &XD->zero) == OK)
	{
	    sendack (X, 1, inblk);	/* ack the header */
	    if (!*X->xpr_filename)	/* given name takes precedence */
	    {
		if (*XD->DefDir)
		{
		    strcpy (XD->FileName, XD->DefDir);
		}
		strcat (XD->FileName, XD->zero.fnam);
#ifdef QDOS
                {
                    char *p;
                    
		    for (p = XD->FileName; *p; p++)
		    {
		        if (*p == '/' || *p == '.' || *p == '\\')
		        {
			    *p = '_';
		        }
		    }
		}
#endif
	    }

	    if ((left = ByteSwap(XD->zero.flen))    )	/* length to transfer */
	    {
		endblk = (left + 127) / 128 + 1;
	    }
	    XD->filesize = left;
	    if (*XD->FileName)
	    {
	        char temp[50];
		setmem (&u, sizeof (u), 0);
		u.xpru_filename = XD->FileName;

		u.xpru_filesize = XD->filesize;
		sprintf(temp, "Receiving File from %s",
                    (XD->zero.prog) ? XD->zero.prog : "?");
		u.xpru_msg = temp;
		u.xpru_errormsg = "";
		u.xpru_blocksize = 128;
		u.xpru_blockcheck = (XD->chktec) ? "CRC-16" : "Checksum";
		u.xpru_updatemask = XPRU_FILENAME | XPRU_FILESIZE |
		    XPRU_MSG | XPRU_ERRORMSG | XPRU_BLOCKS | XPRU_BLOCKSIZE |
		    XPRU_BLOCKCHECK;
		(*X->xpr_update) (&u);
	    }
	    goto ackblock;
	}
	else
	{
	    XD->numerrs++;
	    DOUpdate (X, (XD->chktec) ? CRCERR : CHKERR);
	    goto nakblock;	/* bad header block */
	}
    }
    else if (inblk < c || inblk > c + 100)	/* else if resending what we have */
    {
	getblock (X, buf);		/* ignore it */
	sendack (X, 1, inblk);	/* but ack it */
	DOUpdate (X, DUPSEC);
	goto ackblock;
    }
    else
	/* else if running ahead */
    {
	DOUpdate (X, FUTURE);
	goto nextblock;
    }

  endrcv:
  
    sendack (X, 0, blknum);
    if (com_getc (X, 20) != EOT)
    {
	DOUpdate (X, WCEOT);
	goto nakblock;
    }
    sendack (X, 1, blknum);

    if (blknum > 1)		/* if we really got anything */
    {
#if 0
	if (zero.fstamp)	/* set stamp, if known */
	    setstamp (f, zero.fstamp);
#endif
	(*X->xpr_fclose) (XD->fp);
	(*X->xpr_unlink) (XD->FileName);	/* rename temp to proper name */
	rename (tmpname, XD->FileName);
	return OK;		/* signal what file we got */
    }
    else
	/* else no real file */
    {
	(*X->xpr_fclose) (XD->fp);
	(*X->xpr_unlink) (tmpname);
	return ERROR;		/* signal end of transfer */
    }

  abort:
    if (XD->fp)
    {
	(*X->xpr_fclose) (XD->fp);
    }

    return ERROR;
}

static sendack (X, acknak, blknum)	/* send an ACK or a NAK */
PXIO X;
int acknak;			/* 1=ACH, 0=NAK */
int blknum;			/* block number */
{
    if (acknak)			/* send the right signal */
	com_putc (X, ACK);
    else if (XD->chktec)
	com_putc (X, 'C');
    else
	com_putc (X, NAK);

    com_putc (X, blknum);		/* block number */
    com_putc (X, blknum ^ 0xff);	/* block number check */
}

static int getblock (X, buf)	/* read a block of data */
PXIO X;
char *buf;			/* data buffer */
{
    int ourcrc = 0, hiscrc;	/* CRC check values */
    int c;			/* one byte of data */
    int n;			/* index */

    for (n = 0; n < 128; n++)
    {
	if ((c = com_getc (X, 5)) == EOF)
	{
	    return ERROR;
	}
	if (XD->chktec)
	    ourcrc = crc_update (ourcrc, c);
	else
	    ourcrc += c;
	*buf++ = c;
    }

    if (XD->chktec)
    {
	ourcrc = crc_finish (ourcrc);
	hiscrc = (com_getc (X, 5) << 8) | com_getc (X, 5);
    }
    else
    {
	ourcrc &= 0xff;
	hiscrc = com_getc (X, 5) & 0xff;
    }

    if (ourcrc == hiscrc)
	return OK;
    else
    {
	return ERROR;
    }
}

XProtocolSend (X)
PXIO X;
{
    unsigned char single, done = FALSE;
    int fstate;

    if (XSetup (X) == OK)
    {
	XD->starttime = time (NULL);
	if (!X->xpr_ffirst || !X->xpr_fnext)
	{
	    single = TRUE;
	    strcpy (XD->FileName, X->xpr_filename);
	}
	else
	{
	    single = FALSE;
	    fstate = (*X->xpr_ffirst) (XD->FileName, X->xpr_filename);
	    if (!fstate)
	    {
		DOUpdate (X, NOFILES);
		return ERROR;
	    }
	}
	Welcome (X);
	while (!done)
	{
	    if (xmtfile (X) == ERROR)
		break;
	    if (single)
		break;
	    fstate = (*X->xpr_fnext) (fstate, XD->FileName, X->xpr_filename);
	    done = !fstate;
	}
	*XD->FileName = '\0';
	xmtfile (X);
        DOUpdate (X, DONE);
    }
}

XProtocolReceive (X)
PXIO X;
{
    char err = FALSE;

    /* Perform common setup and initializations */
    if (XSetup (X) == OK)
    {
	Welcome (X);
        *X->xpr_filename = 0;
	while (rcvfile (X) == OK)
	    /* input loop */ ;
    }
    DOUpdate (X, DONE);
    return OK;
}
