#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <string.h>

#include "xproto.h"
#include "xprxmodem.h"

static int Eofseen;		/* indicates cpm eof (^Z) has been received */

XProtocolReceive (IO)
PXIO IO;
{
    int t, s;
    XPRU u;

    setmem(&u, sizeof(XPRU), '\0');

    if (XSetup (IO) == OK)
    {
         if (IO->xpr_filename && *IO->xpr_filename &&
            (XD->fp = (*IO->xpr_fopen) (IO->xpr_filename, "w")) != 0)
         {
            if(IO->xpr_setserial)
	    {
	        (*IO->xpr_setserial)(3);           /* NO xon/xoff */
	    }
            SetTextMode (IO, 0);
            u.xpru_protocol = "XModem";
            u.xpru_filename = IO->xpr_filename;
            u.xpru_filesize = 0;
            u.xpru_msg = "Waiting to receive";
            u.xpru_blocksize = XD->blklen;
            u.xpru_blockcheck = (XD->crcmode) ? "CRC-16" : "Checksum";
            u.xpru_updatemask = XPRU_PROTOCOL | XPRU_FILENAME | XPRU_FILESIZE |
                  XPRU_MSG | XPRU_BLOCKS | XPRU_BLOCKSIZE |
                  XPRU_BYTES | XPRU_ERRORS | XPRU_TIMEOUTS |
                  XPRU_PACKETDELAY | XPRU_CHARDELAY | XPRU_BLOCKCHECK |
                  XPRU_DATARATE;
            (*IO->xpr_update) (&u);
            if (wcrx (IO) == ERROR)
            {
                 (*IO->xpr_fclose) (XD->fp);
                  canit (IO);
             }
             DOUpdate (IO, DONE);
         }
         else
         {
             DOUpdate (IO, FILERR);
             canit (IO);
         }
    }
}

wcrx (IO)
PXIO IO;
{
    int sectcurr;
    char sendchar;
    char *p;

    XD->firstsec = TRUE;
    XD->blknum = 0;
    Eofseen = FALSE;

    sendchar = XD->crcmode ? WANTCRC : NAK;
    XD->starttime = time (NULL);
    for (;;)
    {
	sendline (IO, sendchar);/* send it now, we're ready! */
	sectcurr = wcgetsec (IO, 100);
	if (sectcurr == (XD->blknum + 1 & 0377))
	{
	    XD->blknum++;
	    XD->bytes += XD->blklen;
	    DOUpdate (IO, OK);
	    if (putsec (IO) == ERROR)
	    {
		return ERROR;
	    }
	    sendchar = ACK;
	}
	else if (sectcurr == (XD->blknum & 0377))
	{
	    XD->numerrs++;
	    DOUpdate (IO, DUPSEC);
	    sendchar = ACK;
	}
	else if (sectcurr == WCEOT)
	{
	    DOUpdate (IO, DONE);
	    (*IO->xpr_fclose) (XD->fp);
	    sendline (IO, ACK);
	    return OK;
	}
	else if (sectcurr == ERROR)
	{
	    /*
	     * DOUpdate(IO, STRANGE);
	     */
	    return ERROR;
	}
	else
	{
	    DOUpdate (IO, NOSYNC);
	    return ERROR;
	}
    }
}

wcgetsec (IO, maxtime)
PXIO IO;
int maxtime;
{
    int checksum, wcj, firstch;
    unsigned short oldcrc;
    char *p;
    int sectcurr;
    int elimit;
    int Lastrx;
    int errors;

    elimit = ERRORMAX;
    if (!XD->crcmode)
    {
	elimit /= 2;
    }

    for (Lastrx = errors = 0; errors < elimit; errors++)
    {

	if (IO->xpr_chkabort)
	{
	    if ((XD->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	firstch = readline (IO, maxtime);

	if (firstch == STX)
	{
	    XD->blklen = 1024;
	    goto get2;
	}
	if (firstch == SOH)
	{
	    XD->blklen = 128;
	  get2:
	    sectcurr = readline (IO, 10);
	    oldcrc = readline (IO, 10);
	    if ((sectcurr + oldcrc) == 0377)
	    {
		oldcrc = checksum = 0;
		if(XD->firstsec)
		{
		    DOUpdate(IO, RECV_START);
		}
		for (p = (char *)XD->packet, wcj = XD->blklen; --wcj >= 0;)
		{
		    if ((firstch = readline (IO, 10)) < 0)
			goto bilge;
		    oldcrc = updcrc (firstch, oldcrc);
		    checksum += firstch;
		    *p++ = firstch;
		}
		if ((firstch = readline (IO, 10)) < 0)
		    goto bilge;
		if (XD->crcmode)
		{
		    oldcrc = updcrc (firstch, oldcrc);
		    if ((firstch = readline (IO, 10)) < 0)
			goto bilge;
		    oldcrc = updcrc (firstch, oldcrc);
		    if (oldcrc & 0xFFFF)
		    {
			XD->numerrs++;
			DOUpdate (IO, CRCERR);
		    }
		    else
		    {
			XD->firstsec = FALSE;
			return sectcurr;
		    }
		}
		else if (((checksum - firstch) & 0377) == 0)
		{
		    XD->firstsec = FALSE;
		    return sectcurr;
		}
		else
		{
		    XD->numerrs++;
		    DOUpdate (IO, CHKERR);
		}
	    }
	    else
	    {
		XD->numerrs++;
		DOUpdate (IO, GARBLE);
	    }
	}
	else if (firstch == EOT)
	{
	    return WCEOT;
	}
	else if (firstch == CAN)
	{
	    if (Lastrx == CAN)
	    {
		DOUpdate (IO, CAN);
		return ERROR;
	    }
	    else
	    {
		Lastrx = CAN;
		continue;
	    }
	}
	else if (firstch == TIMEOUT)
	{
	    if (XD->firstsec)
		goto humbug;
	  bilge:
	    XD->numtime++;
	    DOUpdate (IO, TIMEOUT);
	}
	else
	{
	    XD->numerrs++;
	    DOUpdate (IO, firstch);
	}
      humbug:
	Lastrx = 0;
	while (readline (IO, 4) > 0) ;

	if (XD->firstsec)
	{
	    if (XD->crcmode && errors == ERRORMAX / 2)
	    {
		XD->crcmode = 0;
	    }
	    XD->numtime++;
	    DOUpdate (IO, TIMEOUT);
	    sendline (IO, XD->crcmode ? WANTCRC : NAK);
	}
	else
	{
	    /* non-first sector Time out */
	    sendline (IO, NAK);
	}
    }
    /* try to stop the bubble machine. */
    return ERROR;
}

/*
 * Putsec writes the n characters of buf to receive file fout. If not in
 * binary mode, carriage returns, and all characters starting with CPMEOF are
 * discarded.
 */
putsec (IO)
PXIO IO;
{

    char *p;
    int n;

    if ((n = XD->blklen) == 0)
	return OK;
    if (!XD->Ascii)
    {
	(*IO->xpr_fwrite) (XD->packet, 1, n, XD->fp);
    }
    else
    {
	if (Eofseen)
	    return OK;
	for (p = (char *) XD->packet; --n >= 0; ++p)
	{
	    if (*p == '\r')
		continue;
	    if (*p == CPMEOF)
	    {
		Eofseen = TRUE;
		return OK;
	    }
	    (*IO->xpr_fwrite) (p, 1, 1, XD->fp);
	}
    }
    return OK;
}
