#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>

#include <sys/stat.h>
#include "xproto.h"
#include "xprxmodem.h"

#define RXTIMEOUT 60


XProtocolSend (IO)
struct XPR_IO *IO;
{

    if(IO->xpr_setserial)
    {
        (*IO->xpr_setserial)(3);
    }
    if (wcsend (IO) == ERROR)
    {
         canit (IO);
         (*IO->xpr_sflush) ();
    }
    else
    {
         DOUpdate (IO, DONE);
    }
    if ( ((PXPD)IO->xpr_data)->fp)
    {
       (*IO->xpr_fclose) (((PXPD)IO->xpr_data)->fp);
    }
}

wcsend (IO)
PXIO IO;
{
    int n;
    XPRU u;
    int r = ERROR;

    if (XSetup (IO) == OK)
    {
         setmem(&u, sizeof(XPRU), '\0');
         ((PXPD)IO->xpr_data)->firstsec = TRUE;
         SetTextMode (IO, 1);
         ((PXPD)IO->xpr_data)->fp = (*IO->xpr_fopen) (IO->xpr_filename, "r");

         if (((PXPD)IO->xpr_data)->fp)
         {
             ((PXPD)IO->xpr_data)->filesize = (*IO->xpr_finfo) (IO->xpr_filename, 1);
             ((PXPD)IO->xpr_data)->LFseen = 0;
             ((PXPD)IO->xpr_data)->starttime = time (NULL);
             u.xpru_protocol = "XModem";
             u.xpru_filename = IO->xpr_filename;
             u.xpru_filesize = ((PXPD)IO->xpr_data)->filesize;
             u.xpru_msg = "Waiting to start";
             u.xpru_blocksize = ((PXPD)IO->xpr_data)->blklen;
             u.xpru_blockcheck = (((PXPD)IO->xpr_data)->crcmode) ? "CRC-16" : "Checksum";
             u.xpru_updatemask = XPRU_PROTOCOL | XPRU_FILENAME | XPRU_FILESIZE |
                  XPRU_MSG | XPRU_BLOCKS | XPRU_BLOCKSIZE |
                  XPRU_BYTES | XPRU_ERRORS | XPRU_TIMEOUTS |
                  XPRU_PACKETDELAY | XPRU_CHARDELAY | XPRU_BLOCKCHECK |
                  XPRU_DATARATE;
             (*IO->xpr_update) (&u);
             r = wctx (IO);
         }
         else
         {
             DOUpdate (IO, FILERR);
         }
    }
    return r;
}

wctx (IO)
PXIO IO;
{
    int sectnum, attempts, firstch;
    int err;
    int Done = 0;

    ((PXPD)IO->xpr_data)->bytes = 0;
    ((PXPD)IO->xpr_data)->firstsec = TRUE;
    ((PXPD)IO->xpr_data)->blknum = 0;
    for (attempts = 0; attempts < ERRORMAX && !Done; attempts++)
    {
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD)IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	firstch = readline (IO, RXTIMEOUT);
	if (firstch == NAK || firstch == WANTCRC || firstch == CAN)
	{
	    Done = 1;
	}
	else
	{
	    if (firstch == TIMEOUT)
	    {
		((PXPD)IO->xpr_data)->numtime++;
	    }
	    else
	    {
		((PXPD)IO->xpr_data)->numerrs++;
	    }
	    DOUpdate (IO, firstch);
	}
    }
    if (!Done)
    {
	return ERROR;
    }
    if (firstch == CAN)
    {
	DOUpdate (IO, CAN);
	return ERROR;
    }
    if (firstch == WANTCRC)
    {
	((PXPD)IO->xpr_data)->crcmode = TRUE;
    }
    DOUpdate (IO, SEND_START);
    for (;;)
    {
	if (((PXPD)IO->xpr_data)->filesize <= (((PXPD)IO->xpr_data)->bytes + 896L))
	    ((PXPD)IO->xpr_data)->blklen = 128;
	if (!filbuf (IO))
	    break;
	if (wcputsec (IO) == ERROR)
	    return ERROR;
	((PXPD)IO->xpr_data)->bytes += ((PXPD)IO->xpr_data)->blklen;
	DOUpdate (IO, OK);
    }
    (*IO->xpr_fclose) (((PXPD)IO->xpr_data)->fp);
    ((PXPD)IO->xpr_data)->fp = 0;
    attempts = 0;
    do
    {
	(*IO->xpr_sflush) ();
	sendline (IO, EOT);
	++attempts;
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD)IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}

    }
    while ((firstch = (readline (IO, RXTIMEOUT)) != ACK) && attempts < RETRYMAX);
    if (attempts == RETRYMAX)
    {
	DOUpdate (IO, WCEOT);
	return ERROR;
    }
    else
    {
	return OK;
    }
}

wcputsec (IO)
PXIO IO;
{
    int checksum, wcj;
    char *cp;
    unsigned oldcrc;
    int firstch;
    int attempts;
    int Lastrx;

    firstch = 0;		/* part of logic to detect CAN CAN */

    ((PXPD)IO->xpr_data)->blknum++;

    for (attempts = 0; attempts <= RETRYMAX; attempts++)
    {
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD)IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	Lastrx = firstch;
	sendline (IO, ((PXPD)IO->xpr_data)->blklen == 1024 ? STX : SOH);
	sendline (IO, ((PXPD)IO->xpr_data)->blknum);
	sendline (IO, -(((PXPD)IO->xpr_data)->blknum + 1));
	oldcrc = checksum = 0;
	for (wcj = ((PXPD)IO->xpr_data)->blklen, cp = (char *)((PXPD)IO->xpr_data)->packet; --wcj >= 0;)
	{
	    sendline (IO, *cp);
	    oldcrc = updcrc ((0377 & *cp), oldcrc);
	    checksum += *cp++;
	}
	if (((PXPD)IO->xpr_data)->crcmode)
	{
	    oldcrc = updcrc (0, updcrc (0, oldcrc));
	    sendline (IO, (int) oldcrc >> 8);
	    sendline (IO, (int) oldcrc);
	}
	else
	{
	    sendline (IO, checksum);
	}
	firstch = readline (IO, RXTIMEOUT);
      gotnak:
	switch (firstch)
	{
	    case CAN:
		if (Lastrx == CAN)
		{
		  cancan:
		    DOUpdate (IO, CAN);
		    return ERROR;
		}
		break;
	    case TIMEOUT:
		((PXPD)IO->xpr_data)->numtime++;
		DOUpdate (IO, TIMEOUT);
		continue;
	    case WANTCRC:
		if (((PXPD)IO->xpr_data)->firstsec)
		    ((PXPD)IO->xpr_data)->crcmode = TRUE;
	    case NAK:
		((PXPD)IO->xpr_data)->numerrs++;
		DOUpdate (IO, NAK);
		continue;
	    case ACK:
		((PXPD)IO->xpr_data)->firstsec = FALSE;
		return OK;
	    case ERROR:
		((PXPD)IO->xpr_data)->numerrs++;
		DOUpdate (IO, BURST);
		break;
	    default:
		((PXPD)IO->xpr_data)->numerrs++;
		DOUpdate (IO, firstch);
		break;
	}
	for (;;)
	{
	    Lastrx = firstch;
	    if ((firstch = readline (IO, RXTIMEOUT)) == TIMEOUT)
		break;
	    if (firstch == NAK || firstch == WANTCRC)
		goto gotnak;
	    if (firstch == CAN && Lastrx == CAN)
		goto cancan;
	}
    }
    return ERROR;
}

filbuf (IO)
PXIO IO;
{
    char c;
    int m;
    char *p = (char *)((PXPD)IO->xpr_data)->packet;

    if (!((PXPD)IO->xpr_data)->Ascii)
    {
	m = (*IO->xpr_fread) (p, 1, ((PXPD)IO->xpr_data)->blklen, ((PXPD)IO->xpr_data)->fp);
	if (m <= 0)
	    return 0;
	while (m < ((PXPD)IO->xpr_data)->blklen)
	    p[m++] = 032;
	return ((PXPD)IO->xpr_data)->blklen;
    }
    m = ((PXPD)IO->xpr_data)->blklen;
    if (((PXPD)IO->xpr_data)->LFseen)
    {
	*p++ = 012;
	--m;
	((PXPD)IO->xpr_data)->LFseen = 0;
    }
    while ((*IO->xpr_fread) (&c, 1, 1, ((PXPD)IO->xpr_data)->fp) == 1)
    {
	if (c == 012)
	{
	    *p++ = 015;
	    if (--m == 0)
	    {
		((PXPD)IO->xpr_data)->LFseen = TRUE;
		break;
	    }
	}
	*p++ = c;
	if (--m == 0)
	    break;
    }
    if (m == ((PXPD)IO->xpr_data)->blklen)
	return 0;
    else
	while (--m >= 0)
	    *p++ = CPMEOF;
    return ((PXPD)IO->xpr_data)->blklen;
}

/*
 * readline(timeout) reads character(s) from file descriptor 0 timeout is in
 * tenths of seconds
 */
int readline (IO, timeout)
PXIO IO;
int timeout;
{
    unsigned char byt;
    int n;

    n = (*IO->xpr_sread) (&byt, 1, timeout);

    if (n)
    {
	return (int) (byt);
    }
    else
    {
	return TIMEOUT;
    }
}


/* send cancel string to get the other end to shut up */
canit (IO)
PXIO IO;
{
    static char canistr[] =
    {
     24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0
    };

    (*IO->xpr_swrite) (canistr, strlen (canistr));
}

sendline (IO, c)
PXIO IO;
char c;
{
    char b;

    b = c;
    (*IO->xpr_swrite) (&b, 1);
}
