#ifndef XPRKERMIT_H

#define XPRKERMIT_H	1

#include "xproto.h"

/*
 * The abstract data type for setting up XPR Kermit.
 */

typedef struct {
	char FileName[256];
	char defdir[40];
	int ParityFlag,
	TextFlag,
	ConvertFlag,
	MaxPacket,
	BlockCheckType,
	RetryLimit,
	Timeout,
	KeepFlag,
	GetFlag;
} SetupVars;

/* xprkermit.c */
long XProtocolSend(struct XPR_IO *IO);
long XProtocolReceive(struct XPR_IO *IO);
long XProtocolSetup(struct XPR_IO *IO);
int SetupFromString(struct XPR_IO *IO, char *s, SetupVars *sv);
long XProtocolCleanup(struct XPR_IO *IO);
int XPRParity(struct XPR_IO *IO);
void XPRLong(struct XPR_IO *IO, long i);
void ioerr(struct XPR_IO *IO, char *msg);

#endif
