
#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <string.h>

#include "xproto.h"
#include "xprymodem.h"

static int Eofseen;		/* indicates cpm eof (^Z) has been received */
static int BLeft;

XProtocolReceive (IO)
PXIO IO;
{
    if(IO->xpr_setserial)
    {
        (*IO->xpr_setserial)(3);
    }
    for (;;)
    {
	XSetup (IO);
	XD->Ascii = 0;
	if (wcrxpn (IO) == ERROR)
	    goto fubar;
	if (XD->packet[0] == 0)
	    break;
	if (procheader (IO) == ERROR)
	    goto fubar;
	if (wcrx (IO) == ERROR)
	    goto fubar;

    }
    DOUpdate (IO, DONE);
    return OK;
  fubar:
    (*IO->xpr_fclose) (XD->fp);
    XD->fp = NULL;
    canit (IO);
    return ERROR;
}

wcrxpn (IO)
PXIO IO;
{
    int c;
    XPRU u;

    memset (&u, '\0', sizeof (XPRU));

    (*IO->xpr_sflush) ();

    XD->starttime = time (NULL);
    u.xpru_protocol = "YModem";
    u.xpru_msg = "Waiting ....";
    u.xpru_blocksize = (XD->Kblocks) ? 1024 : 128;
    u.xpru_blockcheck = (XD->crcmode) ? "CRC-16" : "Checksum";
    u.xpru_updatemask = XPRU_PROTOCOL | XPRU_FILESIZE |
	XPRU_MSG | XPRU_BLOCKS | XPRU_BLOCKSIZE |
	XPRU_ERRORS | XPRU_TIMEOUTS |
	XPRU_PACKETDELAY | XPRU_CHARDELAY | XPRU_BLOCKCHECK;
	
    (*IO->xpr_update) (&u);
  et_tu:
    XD->firstsec = TRUE;
    Eofseen = FALSE;

    if(XD->useG)
    {
        c = WANTG;
    }
    else
    {
        c = XD->crcmode ? WANTCRC : NAK;
    }
    sendline (IO, c);    

    while ((c = wcgetsec (IO, 100)) != 0)
    {
	if (c == WCEOT)
	{
	    sendline (IO, ACK);
	    readline (IO, 1);
	    goto et_tu;
	}
	return ERROR;
    }
    sendline (IO, ACK);
    return OK;
}

procheader (IO)
PXIO IO;
{
    char *name, *p;
    int dummy;
    XPRU u;
    int n;
    char buff[64];
    
    name = (char *)XD->packet;

    p = name + 1 + strlen (name);
    if (*p)
    {
	sscanf (p, "%ld%", &(XD->filesize));
    }

    strcpy (IO->xpr_filename, XD->DefDir);
    strcat (IO->xpr_filename, name);
#ifdef QDOS
    for (p = IO->xpr_filename; *p; p++)
    {
	if (*p == '/' || *p == '.' || *p == '\\')
	{
	    *p = '_';
	}
    }
#endif

    if (exist (IO))
    {
	if(XD->overwrite == 'D')
	{
            strcpy (buff, IO->xpr_filename);
	    strcat (IO->xpr_filename, "_dup");
	    n = 2;
	    while (exist (IO))
	    {
	        sprintf (IO->xpr_filename, "%s_dup%ld", buff, n);
	        ++n;
	    }
	}
    }

    if ((XD->fp = (*IO->xpr_fopen) (IO->xpr_filename, "w")))
    {
	XD->starttime = time (NULL);
	memset(&u, 0, sizeof(XPRU));
	u.xpru_protocol = "YModem";
	u.xpru_filename = IO->xpr_filename;
	u.xpru_filesize = XD->filesize;
	u.xpru_blocksize = XD->blklen;
	u.xpru_blockcheck = (XD->crcmode) ? "CRC-16" : "Checksum";
	u.xpru_updatemask = XPRU_PROTOCOL | XPRU_FILENAME | XPRU_FILESIZE |
	    XPRU_BLOCKS | XPRU_BLOCKSIZE |
	    XPRU_BYTES | XPRU_ERRORS | XPRU_TIMEOUTS |
	    XPRU_PACKETDELAY | XPRU_CHARDELAY | XPRU_BLOCKCHECK |
	    XPRU_DATARATE;
	(*IO->xpr_update) (&u);
	return OK;
    }
    else
    {
	DOUpdate (IO, FILERR);
	return ERROR;
    }

}


wcrx (IO)
PXIO IO;
{
    int sectcurr;
    char sendchar;
    char *p;

    XD->firstsec = TRUE;
    XD->blknum = 0;
    Eofseen = FALSE;

    if(XD->useG)
    {
        sendchar = WANTG;
    }
    else
    {
        sendchar = XD->crcmode ? WANTCRC : NAK;
    }

    BLeft = XD->filesize;
    
    for (;;)
    {
	sendline (IO, sendchar);/* send it now, we're ready! */
	sectcurr = wcgetsec (IO, 100);
	if (sectcurr == (XD->blknum + 1 & 0377))
	{
	    XD->blknum++;
	    XD->bytes += XD->blklen;
	    DOUpdate (IO, OK);
	    if (putsec (IO) == ERROR)
	    {
		return ERROR;
	    }
	    sendchar = ACK;
	}
	else if (sectcurr == (XD->blknum & 0377))
	{
	    XD->numerrs++;
	    DOUpdate (IO, DUPSEC);
	    sendchar = ACK;
	}
	else if (sectcurr == WCEOT)
	{
	    DOUpdate (IO, DONE);
	    (*IO->xpr_fclose) (XD->fp);
	    XD->fp = NULL;
	    sendline (IO, ACK);
	    return OK;
	}
	else if (sectcurr == ERROR)
	{
	    /*
	     * DOUpdate(IO, STRANGE);
	     */
	    return ERROR;
	}
	else
	{
	    DOUpdate (IO, NOSYNC);
	    return ERROR;
	}
    }
}

wcgetsec (IO, maxtime)
PXIO IO;
int maxtime;
{
    int checksum, wcj, firstch;
    unsigned short oldcrc;
    char *p;
    int sectcurr;
    int elimit;
    int Lastrx;
    int errors;

    elimit = ERRORMAX;
    if (!XD->crcmode)
    {
	elimit /= 2;
    }

    for (Lastrx = errors = 0; errors < elimit; errors++)
    {

	if (IO->xpr_chkabort)
	{
	    if ((XD->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	firstch = readline (IO, maxtime);

	if (firstch == STX)
	{
	    XD->blklen = 1024;
	    goto get2;
	}
	if (firstch == SOH)
	{
	    XD->blklen = 128;
	  get2:
	    sectcurr = readline (IO, 10);
	    oldcrc = readline (IO, 10);
	    if ((sectcurr + oldcrc) == 0377)
	    {
		oldcrc = checksum = 0;

		if (XD->firstsec)
		{
		    DOUpdate (IO, RECV_START);
		}

		for (p = (char *)XD->packet, wcj = XD->blklen; --wcj >= 0;)
		{
		    if ((firstch = readline (IO, 10)) < 0)
			goto bilge;
		    oldcrc = updcrc (firstch, oldcrc);
		    checksum += firstch;
		    *p++ = firstch;
		}
		if ((firstch = readline (IO, 10)) < 0)
		    goto bilge;
		if (XD->crcmode)
		{
		    oldcrc = updcrc (firstch, oldcrc);
		    if ((firstch = readline (IO, 10)) < 0)
			goto bilge;
		    oldcrc = updcrc (firstch, oldcrc);
		    if (oldcrc & 0xFFFF)
		    {
			XD->numerrs++;
			DOUpdate (IO, CRCERR);
		    }
		    else
		    {
			XD->firstsec = FALSE;
			return sectcurr;
		    }
		}
		else if (((checksum - firstch) & 0377) == 0)
		{
		    XD->firstsec = FALSE;
		    return sectcurr;
		}
		else
		{
		    XD->numerrs++;
		    DOUpdate (IO, CHKERR);
		}
	    }
	    else
	    {
		XD->numerrs++;
		DOUpdate (IO, GARBLE);
	    }
	}
	else if (firstch == EOT)
	{
	    return WCEOT;
	}
	else if (firstch == CAN)
	{
	    if (Lastrx == CAN)
	    {
		DOUpdate (IO, CAN);
		return ERROR;
	    }
	    else
	    {
		Lastrx = CAN;
		continue;
	    }
	}
	else if (firstch == TIMEOUT)
	{
	    if (XD->firstsec)
		goto humbug;
	  bilge:
	    XD->numtime++;
	    DOUpdate (IO, TIMEOUT);
	}
	else
	{
	    XD->numerrs++;
	    DOUpdate (IO, firstch);
	}
      humbug:
	Lastrx = 0;
	while (readline (IO, 4) > 0) ;

	if (XD->firstsec)
	{
	    if (XD->crcmode && errors == ERRORMAX / 2)
	    {
		XD->crcmode = 0;
	    }
	    XD->numtime++;
	    DOUpdate (IO, TIMEOUT);
	    sendline (IO, XD->crcmode ? WANTCRC : NAK);
	}
	else
	{
	    /* non-first sector Time out */
	    sendline (IO, NAK);
	}
    }
    /* try to stop the bubble machine. */
    return ERROR;
}

/*
 * Putsec writes the n characters of buf to receive file fout. If not in
 * binary mode, carriage returns, and all characters starting with CPMEOF are
 * discarded.
 */
putsec (IO)
PXIO IO;
{

    char *p;
    int n;

    if(BLeft > XD->blklen)
    {
        n = XD->blklen;
    }
    else
    {
        n = BLeft;
    }

    BLeft -= n;	
    	
    if (n <= 0)
    {
	return OK;
    }

    if (!XD->Ascii)
    {
	(*IO->xpr_fwrite) (XD->packet, 1, n, XD->fp);
    }
    else
    {
	if (Eofseen)
	    return OK;
	for (p = (char *)XD->packet; --n >= 0; ++p)
	{
	    if (*p == '\r')
		continue;
	    if (*p == CPMEOF)
	    {
		Eofseen = TRUE;
		return OK;
	    }
	    (*IO->xpr_fwrite) (p, 1, 1, XD->fp);
	}
    }
    return OK;
}
int exist (IO)
PXIO IO;
{
    int file;

    file = (*IO->xpr_fopen) (IO->xpr_filename, "r");
    if (file)
    {
	(*IO->xpr_fclose) (file);
	return TRUE;
    }
    else
    {
	return FALSE;
    }
}
