
#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>

#include <sys/stat.h>
#include "xproto.h"
#include "xprymodem.h"

#define RXTIMEOUT 60

static int Lastrx = 0;

XProtocolSend (IO)
struct XPR_IO *IO;
{
    char single, done = FALSE;
    long fstate;

    XD->filcnt = 0;

    if(IO->xpr_setserial)
    {
        (*IO->xpr_setserial)(3);
    }

    if (!IO->xpr_ffirst || !IO->xpr_fnext)
    {
	single = TRUE;
	strcpy (XD->filename, IO->xpr_filename);
    }
    else
    {
	single = FALSE;
	fstate = (*IO->xpr_ffirst) (XD->filename, IO->xpr_filename);
	if (!fstate)
	{
	    ((PXPD) IO->xpr_data)->starttime = time (NULL);
	    DOUpdate (IO, FILERR);
	    canit (IO);
	    return ERROR;
	}
    }

    /* If using templates, keep getting names & sending until done */
    while (!done)
    {
	XSetup (IO);
	if (wcsend (IO) == ERROR)
	{
	    canit(IO);
	    return ERROR;
	}
	if (single)
	    break;
	fstate = (*IO->xpr_fnext) (fstate, XD->filename, IO->xpr_filename);
	done = !fstate;
    }

    if (XD->filcnt)
    {
	DOUpdate (IO, DONE);
	XD->filename[0] = '\0';
	wctxpn (IO);
    }
    else
    {
	canit (IO);
    }
    return OK;
}

wcsend (IO)
PXIO IO;
{
    int n;
    XPRU u;
    int r = ERROR;

    if (XSetup (IO) == OK)
    {
	setmem (&u, sizeof (XPRU), '\0');
	((PXPD) IO->xpr_data)->firstsec = TRUE;
	XD->Ascii = 0;
    	((PXPD) IO->xpr_data)->filesize = (*IO->xpr_finfo) (XD->filename, 1);
	((PXPD) IO->xpr_data)->fp = (*IO->xpr_fopen) (XD->filename, "r");
	((PXPD) IO->xpr_data)->starttime = 0;

	if (((PXPD) IO->xpr_data)->fp)
	{
	    ((PXPD) IO->xpr_data)->LFseen = 0;
	    u.xpru_protocol = "YModem";
	    u.xpru_filename = XD->filename;
	    u.xpru_filesize = ((PXPD) IO->xpr_data)->filesize;
	    u.xpru_msg = "Waiting to start";
	    u.xpru_blocksize = ((PXPD) IO->xpr_data)->blklen;
	    u.xpru_blockcheck = (((PXPD) IO->xpr_data)->crcmode) ? "CRC-16" : "Checksum";
	    u.xpru_updatemask = XPRU_PROTOCOL | XPRU_FILENAME | XPRU_FILESIZE |
		XPRU_MSG | XPRU_BLOCKS | XPRU_BLOCKSIZE |
		XPRU_BYTES | XPRU_ERRORS | XPRU_TIMEOUTS |
		XPRU_PACKETDELAY | XPRU_CHARDELAY | XPRU_BLOCKCHECK |
		XPRU_DATARATE;
	    (*IO->xpr_update) (&u);
 	    if((r = wctxpn (IO)) == OK)
	    {
	    	r = wctx(IO);
		XD->filcnt++;
	    }
            if(((PXPD) IO->xpr_data)->fp)
            {
                (*IO->xpr_fclose) (((PXPD) IO->xpr_data)->fp);
                ((PXPD) IO->xpr_data)->fp = 0;
	    }
	}
	else
	{
	    DOUpdate (IO, FILERR);
	}
    }
    return r;
}

TXParse (fname, xname)
char *fname;
char *xname;
{
    char *p;
    char *q;
    int n;
    char c;

#ifndef QDOS
    for (p = fname, q = NULL; *p; p)
    {
	if (*p == ':' || *p == '/')
	{
	    q = ++p;
	}
	else
	{
	    p++;
	}
    }
#else
    p = fname;
    q = strchr (p, '_');
    if (q)
    {
	q++;
	c = *q;
	*q = 0;
	if (isdirdev (p))
	{
	    *q = c;
	}
	else
	{
	    *q = c;
	    q = p;
	}
    }
    else
    {
	q = p;
    }
    p = strrchr (q, '_');
    if (p)
    {
	*p = '.';
    }
#endif
    if (q == NULL)
    {
	q = fname;
    }
    strcpy (xname, q);
}

wctxpn (IO)
PXIO IO;
{
    char *p, *q;

    if (getnak (IO))
    {
	return ERROR;
    }

    memset (XD->packet, '\0', (unsigned) 1024L);
    if (*XD->filename)
    {

	TXParse (XD->filename, XD->packet);

	p = (char *)XD->packet + strlen ((char *) XD->packet) + 1;
	sprintf (p, "%lu 0 0 0 0", XD->filesize);
    }
    if (XD->packet[125])
    {
        XD->blklen = 1024;
    }
    else
    {			/* A little goodie for IMP/KMD */
        XD->blklen = 128;
    }

    ((PXPD) IO->xpr_data)->blknum = 0;
    if (wcputsec (IO) == ERROR)
	return ERROR;

    return OK;
}

getnak (PXIO IO)
{
    int firstch;
    int nc;

    Lastrx = 0;

    for (nc = 0;;)
    {
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD) IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return TRUE;
	    }
	}

	switch (firstch = readline (IO, 80))
	{
	    case TIMEOUT:
		XD->numtime++;
		DOUpdate (IO, TIMEOUT);
		nc++;
		if (nc == 10)
		    return TRUE;
		break;
	    case WANTG:
		XD->optiong = TRUE;
		XD->blklen = 1024;
	    case WANTCRC:
		XD->crcmode = TRUE;
	    case NAK:
		return FALSE;
	    case CAN:
		if (Lastrx == CAN)
		    return TRUE;
	    default:
		break;
	}
	Lastrx = firstch;
    }
}

wctx (IO)
PXIO IO;
{
    int sectnum, attempts, firstch;
    int err;
    int Done = 0;

    ((PXPD) IO->xpr_data)->bytes = 0;
    ((PXPD) IO->xpr_data)->firstsec = TRUE;
    ((PXPD) IO->xpr_data)->blknum = 1;

    XD->blklen = (XD->Kblocks) ? 1024 : 128;
    XD->starttime = time(NULL);

    for (attempts = 0; attempts < ERRORMAX && !Done; attempts++)
    {
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD) IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	firstch = readline (IO, RXTIMEOUT);
	if (firstch == NAK || firstch == WANTCRC || 
			      firstch == CAN || firstch == WANTG)
	{
	    Done = 1;
	}
	else
	{
	    if (firstch == TIMEOUT)
	    {
		((PXPD) IO->xpr_data)->numtime++;
	    }
	    else
	    {
		((PXPD) IO->xpr_data)->numerrs++;
	    }
	    DOUpdate (IO, firstch);
	}
    }
    if (!Done)
    {
	return ERROR;
    }
    if (firstch == CAN)
    {
	DOUpdate (IO, CAN);
	return ERROR;
    }
    if (firstch == WANTCRC || firstch == WANTG)
    {
	((PXPD) IO->xpr_data)->crcmode = TRUE;
    }
    DOUpdate (IO, SEND_START);
    for (;;)
    {
	if (XD->filesize <= (XD->bytes + 896))
	{
	    ((PXPD) IO->xpr_data)->blklen = 128;
	}
	if (!filbuf (IO))
	    break;
	if (wcputsec (IO) == ERROR)
	    return ERROR;
	((PXPD) IO->xpr_data)->bytes += ((PXPD) IO->xpr_data)->blklen;
	DOUpdate (IO, OK);
        ((PXPD) IO->xpr_data)->blknum++;
    }

    (*IO->xpr_fclose) (((PXPD) IO->xpr_data)->fp);
    ((PXPD) IO->xpr_data)->fp = 0;
    attempts = 0;

    while(1)
    {
        (*IO->xpr_sflush) ();
	sendline (IO, EOT);
	++attempts;
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD) IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
        firstch = readline (IO, RXTIMEOUT);
	if(firstch == ACK || attempts == RETRYMAX)
	{
	    break;
	}

    }

    if (attempts >= RETRYMAX)
    {
	DOUpdate (IO, WCEOT);
	return ERROR;
    }
    else
    {
	return OK;
    }
}

wcputsec (IO)
PXIO IO;
{
    int checksum, wcj;
    char *cp;
    unsigned oldcrc;
    int firstch;
    int attempts;
    int Lastrx;

    firstch = 0;		/* part of logic to detect CAN CAN */


    for (attempts = 0; attempts <= RETRYMAX; attempts++)
    {
	if (IO->xpr_chkabort)
	{
	    if ((((PXPD) IO->xpr_data)->abort = (*IO->xpr_chkabort) ()))
	    {
		DOUpdate (IO, ABORTED);
		return ERROR;
	    }
	}
	Lastrx = firstch;
	sendline (IO, ((PXPD) IO->xpr_data)->blklen == 1024 ? STX : SOH);
	sendline (IO, ((PXPD) IO->xpr_data)->blknum);
	sendline (IO, -(((PXPD) IO->xpr_data)->blknum + 1));
	oldcrc = checksum = 0;
	for (wcj = ((PXPD) IO->xpr_data)->blklen, cp = (char *)((PXPD) IO->xpr_data)->packet; --wcj >= 0;)
	{
	    sendline (IO, *cp);
	    oldcrc = updcrc ((0377 & *cp), oldcrc);
	    checksum += *cp++;
	}
	if (((PXPD) IO->xpr_data)->crcmode)
	{
	    oldcrc = updcrc (0, updcrc (0, oldcrc));
	    sendline (IO, (int) oldcrc >> 8);
	    sendline (IO, (int) oldcrc);
	}
	else
	{
	    sendline (IO, checksum);
	}
	if (XD->optiong)
	{
	    XD->firstsec = FALSE;
	    return OK;
	}
        firstch = readline (IO, RXTIMEOUT);

gotnak:

	switch (firstch)
	{
	    case CAN:
		if (Lastrx == CAN)
		{
		  cancan:
		    DOUpdate (IO, CAN);
		    return ERROR;
		}
		break;
	    case TIMEOUT:
		((PXPD) IO->xpr_data)->numtime++;
		DOUpdate (IO, TIMEOUT);
		continue;
	    case WANTCRC:
		if (((PXPD) IO->xpr_data)->firstsec)
		    ((PXPD) IO->xpr_data)->crcmode = TRUE;
	    case NAK:
		((PXPD) IO->xpr_data)->numerrs++;
		DOUpdate (IO, NAK);
		continue;
	    case ACK:
		((PXPD) IO->xpr_data)->firstsec = FALSE;
		return OK;
	    case ERROR:
		((PXPD) IO->xpr_data)->numerrs++;
		DOUpdate (IO, BURST);
		break;
	    default:
		((PXPD) IO->xpr_data)->numerrs++;
		DOUpdate (IO, firstch);
		break;
	}
	for (;;)
	{
	    Lastrx = firstch;
	    if ((firstch = readline (IO, RXTIMEOUT)) == TIMEOUT)
		break;
	    if (firstch == NAK || firstch == WANTCRC)
		goto gotnak;
	    if (firstch == CAN && Lastrx == CAN)
		goto cancan;
	}
    }
    return ERROR;
}

filbuf (IO)
PXIO IO;
{
    char c;
    int m;
    char *p = (char *)((PXPD) IO->xpr_data)->packet;

    if (!((PXPD) IO->xpr_data)->Ascii)
    {
	m = (*IO->xpr_fread) (p, 1, ((PXPD) IO->xpr_data)->blklen, ((PXPD) IO->xpr_data)->fp);
	if (m <= 0)
	    return 0;
	while (m < ((PXPD) IO->xpr_data)->blklen)
	    p[m++] = 032;
	return ((PXPD) IO->xpr_data)->blklen;
    }
    m = ((PXPD) IO->xpr_data)->blklen;
    if (((PXPD) IO->xpr_data)->LFseen)
    {
	*p++ = 012;
	--m;
	((PXPD) IO->xpr_data)->LFseen = 0;
    }
    while ((*IO->xpr_fread) (&c, 1, 1, ((PXPD) IO->xpr_data)->fp) == 1)
    {
	if (c == 012)
	{
	    *p++ = 015;
	    if (--m == 0)
	    {
		((PXPD) IO->xpr_data)->LFseen = TRUE;
		break;
	    }
	}
	*p++ = c;
	if (--m == 0)
	    break;
    }
    if (m == ((PXPD) IO->xpr_data)->blklen)
	return 0;
    else
	while (--m >= 0)
	    *p++ = CPMEOF;
    return ((PXPD) IO->xpr_data)->blklen;
}

/*
 * readline(timeout) reads character(s) from file descriptor 0 timeout is in
 * tenths of seconds
 */
int readline (IO, timeout)
PXIO IO;
int timeout;
{
    unsigned char byt;
    int n;

    n = (*IO->xpr_sread) (&byt, 1, timeout);

    if (n)
    {
	return (int) (byt);
    }
    else
    {
	return TIMEOUT;
    }
}


/* send cancel string to get the other end to shut up */
canit (IO)
PXIO IO;
{
    static char canistr[] =
    {
     24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0
    };

    (*IO->xpr_swrite) (canistr, strlen (canistr));
}

sendline (IO, c)
PXIO IO;
char c;
{
    char b;

    b = c;
    (*IO->xpr_swrite) (&b, 1);
}
